import random
import math
random.seed("personal03/encryption")

class TestGen:
    def __init__(self):
        self.test_number = 0
        self.subtask = ""
        self.desc_file = open("../tests.desc", "w")

    def generate_samples(self):             
        self.print_test(1, 9, "sample 1", 0, "preliminary")
        self.print_test(8, 18, "sample 2", 0, "preliminary")

    def generate_random_test(self, maxn):
        l = random.randint(1, maxn)
        r = random.randint(l, maxn)
        self.print_test(l, r, "random test, l = %d, r = %d" % (l, r))

    def generate_first_group_of_tests(self, folder):
        self.subtask = folder
        self.print_test(1, 1, "min test, l = 1, r = 1")
        self.print_test(1, 1000, "l = 1, r = 1000")
        self.print_test(5, 111, "l = 5, r = 111")
        self.print_test(5, 100, "l = 5, r = 100")
        self.print_test(101, 101, "l = 101, r = 101")
        self.print_test(101, 102, "l = 101, r = 102")
        self.print_test(101, 199, "l = 101, r = 199")
        self.print_test(9, 1000, "l = 9, r = 1000")
        self.print_test(101, 1000, "l = 101, r = 1000")
        self.print_test(499, 1000, "l = 499, r = 1000")
        self.print_test(999, 1000, "l = 999, r = 1000")
        self.print_test(1000, 1000, "l = 1000, r = 1000")
        self.print_test(239, 239, "l = 239, r = 239")
        self.print_test(299, 301, "l = 299, r = 301")
        self.print_test(300, 300, "l = 300, r = 300")

    def generate_second_group_of_tests(self, folder):
        self.subtask = folder
        self.print_test(1, 1, "min test, l = 1, r = 1")
        self.print_test(1, 1000, "l = 1, r = 1000")
        self.print_test(1, 10**6, "l = 1, r = 10^6")
        self.print_test(1, 10**9, "l = 1, r = 10^6")
        self.print_test(1, 10**12, "l = 1, r = 10^12")
        self.print_test(1, 10**15, "l = 1, r = 10^15")
        self.print_test(1, 10**18, "l = 1, r = 10^18")
        self.print_test(1, 10**18 - 1, "l = 1, r = 10^18 - 1")
        for i in range(5):
            r = random.randint(1, 10**18)
            self.print_test(1, r, "random test, l = 1, r = %d" % r)

    def generate_third_group_of_tests(self, folder):
        self.subtask = folder
        for i in range(8):
            digits = random.randint(1, 15)
            s = 0
            for j in range(1, digits):
                s += 10**(j - 1) * 9 * j
            x = random.randint(0, 10**digits - 2)
            s1 = s + digits * x + 1

            digitsR = digits
            y = random.randint(x, 10**digitsR - 2)
            s2 = s + digitsR * (y + 1)
            self.print_test(s1, s2, "l = %d, r = %d" % (s1, s2))

            digitsR = random.randint(digits + 1, 16)
            s = 0
            for j in range(1, digitsR):
                s += 10**(j - 1) * 9 * j
            y = random.randint(0, 10**digitsR - 2)
            s2 = s + digitsR * (y + 1)
            self.print_test(s1, s2, "l = %d, r = %d" % (s1, s2))

    def generate_fourth_group_of_tests(self, folder):
        self.subtask = folder
        self.print_test(1, 1, "min test, l = 1, r = 1")
        self.print_test(5, 111, "l = 5, r = 111")
        self.print_test(5, 100, "l = 5, r = 100")
        self.print_test(101, 101, "l = 101, r = 101")
        self.print_test(101, 102, "l = 101, r = 102")
        self.print_test(9, 1000, "l = 9, r = 1000")
        x = 10**18 // 2
        self.print_test(x - 2, x, "l = %d, r = %d" % (x, x - 2))
        self.print_test(x - 1, x, "l = %d, r = %d" % (x, x - 1))
        self.print_test(x, x,     "l = %d, r = %d" % (x, x))
        self.print_test(x, x + 1, "l = %d, r = %d" % (x, x + 1))
        self.print_test(x, x + 2, "l = %d, r = %d" % (x, x + 2))
        for i in range(15):
            l = random.randint(1, 10**18)
            r = random.randint(l, 10**18)
            self.print_test(l, r, "l = %d, r = %d" % (l, r))
               
    def print_test(self, l, r, description, points=0, folder="tests"):
        self.test_number += 1
        print("Generating test %d" % self.test_number)
        
        dirname = os.path.join('..', folder)
        test_name = os.path.join(dirname, "{0:0=2d}".format(self.test_number))
        if not os.path.exists(dirname):
            os.makedirs(dirname)
        test_file = open(test_name, "w")
        print(l, r, file=test_file)

        print(test_name + ", folder=" + folder + ", subtask=" + self.subtask + ", points=" + str(points) + ", comment=\"" + description + "\"", file=self.desc_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples() 
        self.test_number = 0
        
        #First group of tests
        self.generate_first_group_of_tests("subtask1")
        print("comment_subtask1=\"l, r &lt;= 1000\"", file=self.desc_file)
        print("bonus_subtask1=23", file=self.desc_file)
        
        #Second group of tests
        self.generate_second_group_of_tests("subtask2")
        print("comment_subtask2=\"l = 1\"", file=self.desc_file)
        print("bonus_subtask2=26", file=self.desc_file)

        #Third group of tests
        self.generate_third_group_of_tests("subtask3")
        print("comment_subtask3=\"l, r are the bounds of numbers\"", file=self.desc_file)
        print("bonus_subtask3=22", file=self.desc_file)

        #Fourth group of tests
        self.generate_fourth_group_of_tests("subtask4")
        print("comment_subtask4=\"l, r &lt;= 10^18\"", file=self.desc_file)
        print("bonus_subtask4=29", file=self.desc_file)
        
        self.desc_file.close()

import os, shutil
if os.path.exists('../tests'):
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
if os.path.exists('../preliminary'):
    shutil.rmtree('../preliminary', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
    os.makedirs('../preliminary')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
