#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <cstring>
using namespace std;
#define TASK "occupation"
const int N = 2005;

vector<int> g[N];
int lev[N], par[N], timeDfs, tin[N], tout[N];
bool isBlack[N], isOccup[N];

void dfs(int v) {
    tin[v] = timeDfs++;
    for (auto to: g[v])
        if (to != par[v]) {
            lev[to] = lev[v] + 1;
            par[to] = v;
            dfs(to);
        }
    tout[v] = timeDfs++;
}

int countBlack(int x, int v) {
    int ret = 0;
    while (x != v) {
        ret += isBlack[x];
        x = par[x];
    }
    return ret;
}

void calcBlack(int v) {
    isBlack[v] |= isOccup[v];
    for (auto to: g[v])
        if (to != par[v]) {
            calcBlack(to);
            isBlack[v] |= isBlack[to];
        }
}

int lca(int x, int y) {
    if (lev[x] < lev[y])
        swap(x, y);
    int diff = lev[x] - lev[y];
    for (;diff > 0; --diff)
        x = par[x];
    while (x != y) {
        x = par[x];
        y = par[y];
    }
    return x;
}

int main() {
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);

    int n, m;
    cin >> n;
    int x, y;
    for (int i = 0; i < n - 1; ++i) {
        scanf("%d%d", &x, &y);
        --x;
        --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(0);

    cin >> m;
    for (int i = 0; i < m; ++i) {
        int t, x, y;
        scanf("%d", &t);
        if (t == 1) {
            scanf("%d", &x);
            --x;
            isOccup[x] ^= 1;
            int mn = -1, mx = -1;
            for (int j = 0; j < n; ++j) {
                if (isOccup[j] && (mn == -1 || tin[j] < tin[mn])) mn = j;
                if (isOccup[j] && (mx == -1 || tin[j] > tin[mx])) mx = j;
            }
            int curLca = lca(mn, mx);
            memset(isBlack, 0, sizeof isBlack);
            calcBlack(curLca);
        } else if (t == 2) {
            scanf("%d%d", &x, &y);
            --x;
            --y;
            int v = lca(x, y);
            int cntX = countBlack(x, v);
            int cntY = countBlack(y, v);
            printf("%d\n", cntX + cntY + isBlack[v]);
        }
    }
    return 0;
}
